var API = 
{
  // init
  Init: function(mode)
  {
    try 
    {
      if(mode == 'background')
      {
        // private window
        this.PrivateWindow = 0;
      
        // private window close
        chrome.windows.onRemoved.addListener(function(windowId)
        {
          if(windowId == API.PrivateWindow)
          API.PrivateWindow = 0;
        });   
      
        // badge
        this.SetBadge('#00ff00');
      }

      this.mode = mode;
    }
    catch(e)
    {
      //
    }
  },

  // setting
  Prefs: function(name,value)
  {
    var custom = 
    {
      // search
      'OpenGoogle':'https://www.google.ru/search?client=opera&q=%s&sourceid=opera&ie=UTF-8&oe=UTF-8',
      'OpenYandex':'http://www.yandex.ru/yandsearch?clid=9582&text=%s&l10n=ru',
      'OpenYoutube':'https://www.youtube.com/results?search_query=%s',
          
      // popup
      'PopupHeight':'400',
      'PopupWidth':'300',
      'PopupTextareaRows':'10',
      'PopupTextareaWrap':'0',
      
      // hotkeys
      'HotkeysGoogle':'S+1',
      'HotkeysYandex':'S+2',
      'HotkeysYoutube':'S+5',
      'HotkeysOpenNormal':'S+3',
      'HotkeysOpenPrivate':'S+4',
      
      'HotkeysAddCurrentURL':'A+1',
      'HotkeysAddText':'A+2',
      'HotkeysAddScreen':'A+3',
      'HotkeysAddAllURL':'A+4',
      
      'HotkeysPasteReport':'P+1',
      
      'HotkeysSocJoin':'Q+1',
      'HotkeysSocShare':'Q+2',
      'HotkeysSocLike':'Q+3',
      'HotkeysYtOpen':'Q+4',
      
      // request
      'RequestTimeout':'30',
      'RequestTryCount':'3',
      
      // reports
      'ReportsAll':'{}',
      'ReportsActive':'0',
      'ReportsScrData':'',
      'ReportsScrURL':'',
      
      'ReportsAutoCreate':'1',
      'ReportsSetIP':'1',
      'ReportsInsertAct':'0',
      'ReportsViewTask':'0',
      'ReportsNewSetActive':'1',
      
      // panel
      'OpenTabType':'0',
      'ScreenAction':'0',
      'AutoLogLink':'0',
      'SocModuleActive':'1',
      'AutoTimer':'0',
      
      // soc-module
      'SocModuleAction':'',

      // act
      'SeosprintAction':'',
      'WmmailAction':'',

      // other
      'InjScrAutoFocus':'1',
      'ReportsBlackDomain':'wmmail.ru\nseosprint.net',
      'NumLinks':'0',
      'SoundNotify':'0',

      // API key
      'APIKey':'empty',
      'LastNews':'0',
    };
    
    if(arguments.length == 1)
    {
      if(localStorage.getItem(name))
        return name == 'ReportsAll' ? JSON.parse(localStorage.getItem(name)) : localStorage.getItem(name);
      else
      {
        localStorage.setItem(name,custom[name]);
        return name == 'ReportsAll' ? JSON.parse(custom[name]) : custom[name];
      }
    }
    else
    {
      var value = (typeof(value) == 'undefined' ? custom[name] : value);
      name == 'ReportsAll' ? localStorage.setItem(name,JSON.stringify(value)) : localStorage.setItem(name,value);
    }
  },

  // create context menu
  CreateContextMenu: function(title,callback,type)
  {
    if(type == 'separator') return chrome.contextMenus.create({type:'separator',contexts:['all']});
    return chrome.contextMenus.create({'title':title,'contexts':['all'],onclick:function(event,tab){callback(event);}});
  },

  // Открыть вкладку
  CreateTab: function(url,private)
  {
    if(!url) return;
    url = this.CheckURL(url);
    var type = (private == '0' ? false : true);
    if(type == false) chrome.tabs.create({'url':url});
    else if(!this.PrivateWindow) chrome.windows.create({'url':url,'incognito': true},function(window){API.PrivateWindow = window.id;});
    else chrome.tabs.create({'windowId':this.PrivateWindow,'url':url});
  },

  // get current url
  GetCurrentURL: function(callback)
  {
    chrome.tabs.query({currentWindow: true, active: true}, function(tab) {callback(tab[0].url);});
  },

  // check URL
  CheckURL: function(url)
  {      
    url = url.replace(/\s+/g,'');  
    if(!/^https?:\/\//i.test(url))
    {
      url = 'http://' + url;
    }
    return url;
  },

  // create report
  CreateReport: function(type,zdid,title,task)
  {
    var reports = this.Prefs('ReportsAll');
    if(this.Prefs('ReportsAutoCreate') == '1' || type == 'blank')
    {
      if(Object.keys(reports).length != 0)
      var id = reports[Object.keys(reports)[Object.keys(reports).length - 1]]['id']+1;
      else
      var id = 1;
      reports['report_'+id] = {id:id,type:type,zdid:zdid,title:title,task:task,view:API.Prefs('ReportsViewTask'),text:''};
      API.Prefs('ReportsAll',reports);
      if(this.Prefs('ReportsActive') == '0' || API.Prefs('ReportsNewSetActive') == '1') API.Prefs('ReportsActive',id);
      if(this.Prefs('ReportsSetIP') == '1') API.SetIP(id);
      else if(API.mode == 'popup') window.location.reload();
      else API.SendMsg({target:'popup',command:'update'});
    }
  },

  // add to report
  AddToReport: function(data,id)
  {
    if(arguments.length == 1) var id = this.Prefs('ReportsActive');
    var reports = this.Prefs('ReportsAll');
    if(!reports['report_'+id]) return;
    if(reports['report_'+id].text.indexOf(data+'\r\n') != -1) return;
    // black
    //if(/^https?:\/\//i.test(data))
    //{
    //  var url = document.createElement("a");
    //  url.href = data;
    //  if(url.hostname && url.hostname.length > 0)
    //  {
    //    var black = API.Prefs('ReportsBlackDomain');
    //    black = black.split('\n');
    //    black = black.filter(function(e){return e});
    //    if(black.indexOf(url.hostname) != -1) return;
    //  }
    //}
    // last
    var last = reports['report_'+id].text.match(/^(?:\d*\. )?https?:\/\//gm);
    if(last && last.length > 0)
    last = last.length;//parseInt(last[last.length-1].replace('. ',''));
    else last = 0;
    if(this.Prefs('NumLinks') == '1' && /^https?:\/\//i.test(data)) data = (last+1)+'. '+data;
    reports['report_'+id].text += data+'\r\n';
    API.Prefs('ReportsAll',reports);
    if(API.mode == 'popup') window.location.reload();
    else API.SendMsg({target:'popup',command:'update'});
    this.CreateNotify('text','Добавлено в отчет - '+data);
  },

  // create notify
  CreateNotify: function(type,text)
  {
    if(this.Prefs('SoundNotify') == '1')
    {
      var wav = new Audio();
      wav.src = chrome.extension.getURL('notify.wav');
      wav.type = 'audio/wav';
      wav.autoplay = true;
    }
    chrome.notifications.update('taskhelper-notify-text',{},function(wasUpdated)
    {
      if(!wasUpdated)
      {
        chrome.notifications.create('taskhelper-notify-text', {type:'basic',title:'Task Helper',message:text,iconUrl:'images/logo_64x64.png'}, function()
        {
          setTimeout(function(){chrome.notifications.clear('taskhelper-notify-text', function(){});},2000);
        });
      }
      else
      {
        chrome.notifications.clear('taskhelper-notify-text', function(){});
        API.CreateNotify(type,text);
      }
    });
  },

  // get report
  GetReport: function(type,id)
  {
    if(arguments.length == 1) var id = this.Prefs('ReportsActive');
    var reports = this.Prefs('ReportsAll');
    if(typeof reports['report_'+id] == 'object') 
    return reports['report_'+id][type];
    else return '';
  },

  // set ip
  SetIP: function(id)
  {
    var post_data = {};
    post_data.act = 'getip';
    post_data.key = API.Prefs('APIKey');

    var id = id || API.Prefs('ReportsActive');
    API.HTTPRequest('POST','http://taskhelper.biz/api.php','user='+JSON.stringify(post_data),function(data)
    {
      if(typeof data == 'object' && data != null)
      {
        if(data.status == 'ok')
        {
          API.AddToReport('IP-адрес: '+data.ip+' , время '+data.time,id);
          API.SetBadge('#00ff00');
        }
        else
        {
          if(data.error)
          API.AddToReport(data.error);
          API.SetBadge('#ff0000');
        }
      }
    });
  },

  // send message
  SendMsg: function(data)
  {
    // ing
    if(data.target == 'inj')
    {
      chrome.tabs.query({active: true, currentWindow: true}, function(tabs)
      {
        chrome.tabs.sendMessage(tabs[0].id, data, function(resp){});  
      });
    }
    else
    {
      chrome.extension.sendMessage(data,function(resp){});
    }
  },
  
  // receive message
  RecvMsg: function(callback)
  {
    chrome.extension.onMessage.addListener(function(event,sender,sendResponse){callback(event);});
  },

  // badge
  SetBadge: function(color,text)
  {
    var text = text || ' ';
    chrome.browserAction.setBadgeBackgroundColor({color:color});
    chrome.browserAction.setBadgeText({text:text});
  },

  // create screenshot
  CreateScreen: function(mode)
  {
    this.SetBadge('#00BFFF');
    if(mode == 'create')
      chrome.tabs.captureVisibleTab(null,{format:'png'},function(image){applyScreenshot(image);});
    else API.UploadScreen();    

    // apply screenshot
    function applyScreenshot(imageData)
    {        
      var data_url = imageData;  
      // edit
      if(API.Prefs('ScreenAction') == '1')
      {
        API.GetCurrentURL(function(url)
        {
          chrome.storage.local.set({ReportsScrData: data_url,ReportsScrURL:url}, function()
          {
            API.CreateTab('http://taskhelper.biz/?p=editor','0');
          });
        });
      }
      // upload
      else
      API.UploadScreen(data_url);
    } 
  },

  // Сохранение скриншота
  UploadScreen: function(data)
  {
    this.CreateNotify('text','Закачка скриншота');
    if(!data)
    {
      chrome.storage.local.get({ReportsScrData:'',ReportsScrURL:''},function(prefs)
      {
        Upload(prefs.ReportsScrData,prefs.ReportsScrURL);
      });
    }
    else
      API.GetCurrentURL(function(url){Upload(data,url);});
    function Upload(data,url)
    {
      API.SetBadge('#00BFFF');
      var base64 = data.split(',')[1];

      var post_data = {};
      post_data.act = 'uploadscreen';
      post_data.key = API.Prefs('APIKey');

    API.HTTPRequest('POST','http://taskhelper.biz/api.php','user='+JSON.stringify(post_data) +'&imageData='+base64+'&url='+encodeURIComponent(url),function(data)
      {
        if(typeof data == 'object' && data != null)
        {
          if(data.status == 'ok')
          {
            API.AddToReport(data.link);
            API.SetBadge('#00ff00');
            API.CreateNotify('text','Скриншот закачан - '+data.link);
          }
          else
          {
            if(data.error)
            API.AddToReport(data.error);
            API.SetBadge('#ff0000');
            API.CreateNotify('text','Ошибка закачки скриншота');
          }
        }
      });
    }
  },

  // xmlhttprequest
  HTTPRequest: function(type,url,data,callback,try_count)
  {   
    var timeout = API.Prefs('RequestTimeout') * 1000;
    var try_count = try_count || API.Prefs('RequestTryCount');
    
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.timeout = timeout;
    xmlhttp.onerror = function()
    {
      callback(null);
      API.SetBadge('#ff0000');
    }
    xmlhttp.ontimeout = function()
    {
      if(try_count!=1)
      {
        try_count = try_count-1;
        API.HTTPRequest(type,url,data,callback,try_count);
      }
      else
      {
        callback(null);
        API.SetBadge('#ff0000');
      }
    };
    xmlhttp.open(type, url, true);
    if(type == 'POST')
    xmlhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xmlhttp.onreadystatechange = function()
    {
      if(xmlhttp.readyState == 4)
      {
        if(xmlhttp.status == 200)
        {
          if(API.debug) console.log(xmlhttp.responseText);
          try
          {
            var response = JSON.parse(xmlhttp.responseText);
          }
          catch (e)
          {
            var response = xmlhttp.responseText;
          }
          API.SetBadge('#00ff00');
          callback(response);
        }
        else
        {
          callback(null);
          API.SetBadge('#ff0000');
        }
      }
    };  
    API.SetBadge('#00BFFF');
    xmlhttp.send(data);
  },

  // get random int
  rndInt: function(min, max)
  {
    return Math.floor(Math.random() * (max - min + 1)) + min;
  },

};