window.addEventListener('load', function()
{
  API.Init('popup');

  // active spoiler
  var selected_spoiler = 0;
  
  // receive message
  API.RecvMsg(function(event)
  {
    switch(event.command)
    {
      case 'update': update(); break;
    }
  });

  API.SetBadge('#00ff00');

  // page size
  document.body.style.height = API.Prefs('PopupHeight')+'px';
  document.body.style.width = API.Prefs('PopupWidth')+'px';
  var height=(document.body.scrollHeight > document.body.offsetHeight)?document.body.scrollHeight:document.body.offsetHeight;
  var width=(document.body.scrollWidth > document.body.offsetWidth)?document.body.scrollWidth:document.body.offsetWidth;

  gebi('main').style.height = (height - 2)+'px';
  gebi('main').style.width = (width - 2)+'px';
  
  gebi('content_reports').style.height = (height - 83)+'px';

  // --- init panel ------------------------------------------------- //
  var buttons = gebc('button');
  for(var i=0; i<buttons.length; i++)
  {
    var b = buttons[i];
    if(b.nodeType == 1 && b.hasAttribute('data-pref'))
    {
      b.title = (API.Prefs(ga(b,'data-pref')) == ga(b,'data-pref1') ? ga(b,'data-title1') : ga(b,'data-title2'));
      b.className = (API.Prefs(ga(b,'data-pref')) == ga(b,'data-pref1') ? ga(b,'data-class1') : ga(b,'data-class2'));
      b.addEventListener('click', function(e)
      {
        var el = e.target;         
        API.Prefs(ga(el,'data-pref'),(el.className == ga(el,'data-class1') ? ga(el,'data-pref2') : ga(el,'data-pref1')));
        el.title = (el.title == ga(el,'data-title1') ? ga(el,'data-title2') : ga(el,'data-title1'));
        el.className = (el.className == ga(el,'data-class1') ? ga(el,'data-class2') : ga(el,'data-class1'));
      });
    }
  }

  // new report
  gebi('b_new').addEventListener('click', function(){
    API.CreateReport('blank',0,'blank','');
  });

  // delete report
  gebi('b_del').addEventListener('click', function(){
    DelReport(selected_spoiler);
  });

  // set ip
  gebi('b_ip').addEventListener('click', function(){
    API.SetIP();
  });

  // show task
  gebi('b_task').addEventListener('click', function(){
    var reports = API.Prefs('ReportsAll');
    if(API.Prefs('ReportsActive') == 0 || API.GetReport('type') == 'blank') return;
    var task = gebi('task_'+API.Prefs('ReportsActive'));
    task.style.display = (task.style.display == 'block' ? 'none' : 'block');
    reports['report_'+API.Prefs('ReportsActive')].view = (reports['report_'+API.Prefs('ReportsActive')].view == '0' ? '1' : '0');
    API.Prefs('ReportsAll',reports);
  });

  // open report form
  gebi('b_area').addEventListener('click', function(){
    var reports = API.Prefs('ReportsAll');
    if(API.Prefs('ReportsActive') == 0 || API.GetReport('type') == 'blank') return;
    var zdid = API.GetReport('zdid');
    switch(API.GetReport('type'))
    {
      case 'wmmail': API.Prefs('WmmailAction','set1'); API.SendMsg({target:'background',command:'openurl',url:'http://wmmail.ru/index.php?cf=uzd-readtask&zdid='+zdid,type:'false'}); break;
      case 'seosprint': API.Prefs('SeosprintAction','set1'); API.SendMsg({target:'background',command:'openurl',url:'http://www.seosprint.net/',type:'false'}); break;
    }
  });

  // clear
  gebi('b_clear').addEventListener('click', function(){
    if(!gebi('report_textarea'+API.Prefs('ReportsActive'))) return;
    var reports = API.Prefs('ReportsAll');
    reports['report_'+API.Prefs('ReportsActive')].text = '';
    API.Prefs('ReportsAll',reports);
    gebi('report_textarea'+API.Prefs('ReportsActive')).value = '';
    if(gebi('count_'+API.Prefs('ReportsActive')))
    gebi('count_'+API.Prefs('ReportsActive')).parentNode.removeChild(gebi('count_'+API.Prefs('ReportsActive')));
  }); 

  // create report element
  function CreateReportEl(id)
  {
    var reports = API.Prefs('ReportsAll');  
    var parent = gebi('content_reports');
    
    // 
    var spoiler = ce('div',{className:'spoiler',id:'spoiler_block'+id});
    
    var spoiler_head = ce('div',{className:'spoiler_head'});
    
    spoiler_head.addEventListener('click', function(){
      var el = gebi('spoiler_content'+id);
      if(el.style.display == 'none')
      Spoiler(id);
    });
    
    // header
    var img = ce('img',{src:'/images/'+reports['report_'+id].type+'_ico_24.png'});
    var title = (reports['report_'+id].type!='blank' ? reports['report_'+id].zdid+" - "+reports['report_'+id].title : reports['report_'+id].title);
    title = document.createTextNode(title);

    var last = reports['report_'+id].text.match(/^(?:\d*\. )?https?:\/\//gm);
    if(last && last.length > 0)
    {
      last = last.length;//parseInt(last[last.length-1].replace('. ',''));
      var count = ce('span',{id:'count_'+id,className:'count',innerText:last});
    }
    
    var spoiler_caption = ce('div',{className:'spoiler_caption',title:reports['report_'+id].title});
    spoiler_caption.appendChild(img);
    spoiler_caption.appendChild(title);
    
    // content
    if(API.Prefs('ReportsActive') != id) var display = 'none';
    else
    {
      var display = 'block';
      selected_spoiler = id;
    }
    var spoiler_content = ce('div',{className:'spoiler_content',id:'spoiler_content'+id,style:{display:display}});
    var spoiler_text = ce('div',{className:'spoiler_text'});

    function press()
    {
      reports['report_'+API.Prefs('ReportsActive')].text = gebi('report_textarea'+API.Prefs('ReportsActive')).value;
      API.Prefs('ReportsAll',reports);
    }
    
    // report
    var wrap = (API.Prefs('PopupTextareaWrap') == '0' ? 'on' : 'off');
    var spoiler_textarea = ce('textarea',{id:'report_textarea'+id,rows:API.Prefs('PopupTextareaRows'),className:'spoiler_textarea',value:reports['report_'+id].text,wrap:wrap});
    spoiler_textarea.addEventListener('keydown', function(){
      setTimeout(press,100);
    });
    spoiler_textarea.addEventListener('keypress', function(){
      setTimeout(press,100);
    });
    spoiler_textarea.addEventListener('keyup', function(){
      setTimeout(press,100);
    });

    // task
    if(API.GetReport('type',id) != 'blank')
    {
      var display = (API.GetReport('view',id) == '0' ? 'none' : 'block');
      var param = {id:'task_'+id,className:'spoiler_task',style:{display:display}};
      param.innerHTML = API.GetReport('task',id).replace(/[\n]+/g,'<br>');
      var spoiler_task = ce('div',param);
      spoiler_text.appendChild(spoiler_task);
    }
    
    spoiler_text.appendChild(spoiler_textarea);
    if(count) {spoiler_text.appendChild(ce('br')); spoiler_text.appendChild(count);}
    spoiler_head.appendChild(spoiler_caption);
    spoiler_content.appendChild(spoiler_text);
    spoiler.appendChild(spoiler_head);
    spoiler.appendChild(spoiler_content);
    parent.appendChild(spoiler);
  }

  // spoiler
  function Spoiler(id) 
  {
    if (selected_spoiler != id && selected_spoiler != 0) 
    {
      gebi('spoiler_content'+selected_spoiler).style.display = 'none';
    }
    
    gebi('spoiler_content'+id).style.display = 'block';
    selected_spoiler = id;
    var textarea = gebi('report_textarea'+id);
    textarea.focus();
    textarea.scrollTop = textarea.scrollHeight;
    setCaretPosition(textarea,textarea.value.length);
  
    API.Prefs('ReportsActive',id);
  }

  // delete report
  function DelReport(id)
  {
    var reports = API.Prefs('ReportsAll');
    if(!reports['report_'+id]) return;
    delete reports['report_'+id];  
    API.Prefs('ReportsAll',reports);
    var element = gebi('spoiler_block'+id);
    element.parentNode.removeChild(element);
    API.Prefs('ReportsActive','0');
    selected_spoiler = 0;
  }

  // load reports
  function LoadReports()
  {
    var el = gebi('content_reports');
    while(el.hasChildNodes()){el.removeChild(el.lastChild);}
  
    var reports = API.Prefs('ReportsAll');
    for(var i in reports)
    {
      CreateReportEl(reports[i]['id']);
    }
  }

  // hotkeys
  var pressed = [];
    
  window.addEventListener('keydown',function(e)
  {
    e = e || window.event;
    pressed.push(String.fromCharCode(e.keyCode));
    if(keys[pressed.join('+')])
    {
      keys[pressed.join('+')]();
      e.preventDefault();
      pressed.splice(0,pressed.length);
    }
  });
    
  window.addEventListener('keyup',function(e)
  {
    e = e || window.event;
    pressed.splice(0,pressed.length);
  });
  
  // get selected text/hover link
  function GetTextHref()
  {
    if(window.getSelection()!='')
    var text = window.getSelection().toString();
    else
    {
      var link = qs(':hover');
      text = link.href;
    }
    return text;
  }
  
  var keys = {};
  keys[API.Prefs('HotkeysGoogle')] = function(){API.SendMsg({target:'background',command:'googlesearch',text:GetTextHref()});};
  keys[API.Prefs('HotkeysYandex')] = function(){API.SendMsg({target:'background',command:'yandexsearch',text:GetTextHref()});};
  keys[API.Prefs('HotkeysOpenNormal')] = function(){API.SendMsg({target:'background',command:'openurl',url:GetTextHref(),type:'false'});};
  keys[API.Prefs('HotkeysOpenPrivate')] = function(){API.SendMsg({target:'background',command:'openurl',url:GetTextHref(),type:'true'});};
  keys[API.Prefs('HotkeysSocJoin')] = function(){API.SendMsg({target:'background',command:'socjoingroup',url:GetTextHref()});};
  keys[API.Prefs('HotkeysSocShare')] = function(){API.SendMsg({target:'background',command:'socshare',url:GetTextHref()});};  
  keys[API.Prefs('HotkeysSocLike')] = function(){API.SendMsg({target:'background',command:'soclike',url:GetTextHref()});};

  // update
  function update()
  {
    window.focus();
    LoadReports();
    if(!gebi('spoiler_block'+API.Prefs('ReportsActive'))) return;
    gebi('spoiler_block'+API.Prefs('ReportsActive')).scrollIntoView();
    var textarea = gebi('report_textarea'+API.Prefs('ReportsActive'));
    textarea.scrollTop = textarea.scrollHeight;
    setCaretPosition(textarea,textarea.value.length);
  }

  update();

});